% /*
% %-------------------------------------------------------------------------%
% % Programmed by: Mozhdeh Seifi - Laboratoire Hubert Curien 
% %                               http://laboratoirehubertcurien.fr/
% % 
% % Contact : corinne.fournier@univ_st_etienne.fr
% % Feb 2012
% %-------------------------------------------------------------------------% 
%  * model_mex.cpp - model of diffraction patterns of a spherical particle on sensor according to formulaa number 2 and 4 in [1].
%  * ======================================================================
%  * Usage: [real_p complex_p jinc]=model_mex(x,y,z,r,pix,lambda,Holosize,flag,K)
%  * ======================================================================
%  * inputs:
%  * x: lateral particle's coordinates (vertical) in pixels. center of indexing is fixed on L/2+1
%  * y: lateral particle's coordinates (horizontal)in pixels. center of indexing is fixed on W/2+1
%  * z: axial coordinate of particle in meter
%  * r: Radius of particle in meter
%  * pix: pixel size of sensor in meter
%  * lambda : wavelenght of laser in meter
%  * sizeH : 1by2 matrix containig number of pixels of horizontal and vertical side of hologram
%  * flag: 0 if only the real values for model in required
%  * K: max{fill-factor of camera, rate of down-sampling}
%  * ======================================================================
%  * Outputs:
%  * real: W by L matrix which contains the real model  
%  * complex: W by L matrix which contains the complex model if flag is nonzero
%  * jinc: W by L matrix which contains the jinc values if r>0
%  * ======================================================================
%  * Test:
%  * [real_p complex_p jinc_p]=model_mex(0,0,0.11,50e-6,7e-6,0.532e-6,[512 1024],1,sqrt(0.7));
%  * ======================================================================
%  * Time on Cetautomatix: 0.2791 seconds - size of model = [1024 1024]
%  * ======================================================================
%  *[1] F. Soulez, L. Denis, E. Thiebaut, C. Fournier, et C. Goepfert, "Inverse problem approach in particle digital holography:
%  * out-of-field particle detection made possible", Journal of the Optical Society of America A, vol. 24, no. 12, p. 3708-3716, 2007
%  * ======================================================================
%  */
