%-------------------------------------------------------------------------%
% Programmed by: Mozhdeh Seifi - Laboratoire Hubert Curien 
%                               http://laboratoirehubertcurien.fr/
%
% Under the supervision of Corinne Fournier and Loic Denis  
%
% Contact : corinne.fournier@univ_st_etienne.fr
% May 2012
%-------------------------------------------------------------------------%
% Welcome.  before starting to use this toolbox, you would need to perform
% some steps:
%
% 1- Set the path of the toolbox directories in Matlab. 
%     There are two ways to do that:
%     The temporary change of the path(recommended)
%       1.1. cd to the directory of tool box : 
%       1.2. type DHtoolPath(pwd) in the command line of Matlab
%    OR the global change of the path:
%       1.1. Choose 'File/Set Path...'
%       1.2. In the opened window, choose the button 'Add with subfolders',
%       and select the folder containig this toolbox - HoloPRO_v1.3
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2- IF YOU HAVE THE C-SOURCE CODES : Compile the mex functions for your PC's configuration
%     To do so:
%     2.1. cd to ~/HoloPRO_v1.3/IPA/C_src
%
%     2.2. Run compile_mex.m
%     - To have a successful compilation, you would need to have a C++ compiler installed on your machine.
%     - If you don't have a C++ compiler, check http://mingw.org/category/wiki/download to download a free one. Note that if your system is Winx64,
%         you will have to install Microsoft Visual C++ instead.
%
%     - FOR SIMPLE USE: For the simple usage through the graphical user interface, you
%       don't need to succeed in the compilation of 'model_mex_faster.cpp'
%       and/or 'Qmap_mex.cpp'.
%
%     - FOR COMPLEX USE ONLY: To be able to compile the mex function 'model_mex_faster.cpp' for the fast model with
%       multi-threading, your compiler should access OpenMP library. If you
%       can't use multi-threading, make sure to provide the argument
%       MEXmodelFAST=0. This will cause the program to run slower.
%
%     - FOR COMPLEX USE ONLY: To see details of compilation of mex functions, check the help of Matlab for mex.
%
%     - FOR COMPLEX USE ONLY: If you can't compile the file 'Qmap_mex.cpp', be careful to set the 
%       parameter MEXQmap=0 wherever it has been asked for (e.g., in the
%       MAIN_IPA.m and MAIN_FAST.m ).
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 3- Start using the toolbox
%
% NOTE : you can find sample holograms and other information
% in the folder ./HoloPRO/Data/, ./HoloPRO/simulations/ and ./HoloPRO/holo_LMFA.
%
%           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLE USE:
%   - You can start working with the toolbox through the Graphical User
%   Interface - To do so, type 'GUI' in the command line. You are ready to
%   go!
% 
%           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% COMPLEX USE:
%   - You can directly check the headers of the files for the directions on
%       the inputs/outputs parameters and test of that function.
%
%   - There are two sample files which allow you to process holograms using
%       inverse problems approach: One for single-scale approach and one for
%       multi-scale approach.
%
%   3.1. Single-scale approach :
%       The corresponding files are located in ~/HoloPRO_v1.3/IPA/. This
%       folder contains:
%       one .m file called 
%           3.1.1. MAIN_IPA.m : this file is the sample file where you can
%                               set the application parameters. please read
%                               the comments to provide the relevant
%                               parameters. 
%                               Some parameters like alpha_threshold are 
%                               practically found according to the application 
%                               (in the case of simulations, this value is 
%                               very close to 2).
%
%       and 5 sub_folders namely: 
%           3.1.2. ./bin : This folder contains the binary files for the
%                           mex functions
%           3.1.3. ./m_src : This folder contains the Matlab source files in .m
%                           format
%           3.1.4. ./help : This folder contains the help files for the mex
%                           functions, e.g., the descriptions on the inputs
%                           and outputs of the functions.
%
%   3.2. Multi-scale approach : 
%       This folder extends the previous part to use pyramidal approach.The corresponding 
%       files are located in ~/HoloPRO_v1.3/FAST/. This folder contains three .m files.
%       one .m file called 
%           3.2.1. MAIN_FAST.m :  this file is the sample file where you can
%                               set the application parameters. please read
%                               the comments to provide the relevant
%                               parameters. 
%                               Using the pyramidal approach, there are some
%                               extra parameters which you would need to set.  
%
%
% ENJOY !
